-- Datenbankcontainer - Demo 1
-- Konfiguration und Verwendung


-----------------------------------------------------------------------
-- SQL Server-Instanz zum Betrieb von Datenbankcontainern konfigurieren
-----------------------------------------------------------------------
USE master
GO

EXEC sp_configure 'show advanced options', 1;
GO
RECONFIGURE WITH OVERRIDE;
GO
EXEC sp_configure 'contained database authentication', 1;
EXEC sp_configure 'show advanced options', 0;
GO
RECONFIGURE WITH OVERRIDE;
GO


--------------------------------------
-- Beispiel-Datenbankcontainer anlegen
--------------------------------------

CREATE DATABASE [SNEK_Container] 
CONTAINMENT = PARTIAL
ON  
PRIMARY 
(NAME = N'SNEK_Container', FILENAME = N'C:\SNEK\Datenbanken\SNEK_Container.mdf')
LOG ON 
(NAME = N'SNEK_Container_log', FILENAME = N'C:\SNEK\Datenbanken\SNEK_Container_log.ldf')
COLLATE Latin1_General_CI_AS
GO


------------------------------------------
-- Benutzer fr Datenbankcontainer anlegen
------------------------------------------
USE SNEK_Container
GO
-- Contained User mit Kennwort
CREATE USER SNEK1 WITH PASSWORD = 'snek1';
GO
ALTER ROLE [db_datareader] ADD MEMBER [SNEK1]
ALTER ROLE [db_datawriter] ADD MEMBER [SNEK1]
GO
-- Windows-Benutzerkonto ohne Verweis auf Login
CREATE USER [SQL2012RTM\Heinz]
GO
ALTER ROLE [db_datareader] ADD MEMBER [SQL2012RTM\Heinz]
ALTER ROLE [db_datawriter] ADD MEMBER [SQL2012RTM\Heinz]
GO


--------------------------------------------------------------
-- Tabelle im Datenbankcontainer anlegen und Daten importieren
--------------------------------------------------------------
USE SNEK_Container
GO
CREATE TABLE dbo.Konferenzen
(
 KonferenzID int IDENTITY NOT NULL,
 Konferenz nvarchar(10) NOT NULL,
 Ort nvarchar(10) NOT NULL,
 Jahr int
 CONSTRAINT [CIX_PK_Konferenzen_KonferenzId] PRIMARY KEY CLUSTERED ([KonferenzID] ASC)
)
GO
INSERT INTO dbo.Konferenzen
VALUES('SNEK1', 'Nrnberg', 2012),('SNEK2', 'Hannover', 2012),
	  ('SEK4', 'Nrnberg', 2011),('SEK3', 'Hannover', 2009),
	  ('SEK2', 'Nrnberg', 2008),('SEK1', 'Hannover', 2007)
GO
SELECT * FROM dbo.Konferenzen
GO


-- Anschlieend ein Backup fr den Datenbankcontainer erstellen
-- und diesen in einer anderen SQL Server-Instanz wiederherstellen.
-- Die beiden Benutzer sind dann im Datenbankcontainer verfgbar.