-- Datenbankcontainer - Demo 2
-- Datenbanksortierung und tempdb


-------------------------------------------------------
-- Beispiel Datenbanksortierung ohne Datenbankcontainer
-------------------------------------------------------

USE [master];
GO

-- Datenbank mit von der SQL Server-Instanz abweichender Sortierung anlegen
CREATE DATABASE [Finnland] COLLATE Finnish_Swedish_100_CI_AI;
GO

USE [Finnland];
GO

-- Tabelle anlegen
CREATE TABLE dbo.Orte
(
    Ort nvarchar(100),
	Region nvarchar(100)
);
INSERT INTO dbo.Orte VALUES('Helsinki', 'Sdfinnland');

-- Temporre Tabelle anlegen
CREATE TABLE #Regionen
(
    Region nvarchar(100)
);
INSERT INTO #Regionen VALUES('Sdfinnland');

-- Tabellen ber Zeichenfolge verknpfen
SELECT * FROM #Regionen INNER JOIN dbo.Orte ON #Regionen.Region = dbo.Orte.Region 
GO --> Fehler wegen Sortierungskonflikt



------------------------------------------
-- Fr den zweiten Teil der Demo aufrumen
------------------------------------------
DROP TABLE #Regionen;
GO
USE master
GO
DROP DATABASE Finnland;
GO



------------------------------------------------------
-- Beispiel Datenbanksortierung mit Datenbankcontainer
------------------------------------------------------

USE [master];
GO

-- Datenbankcontainer mit von der SQL Server-Instanz abweichender Sortierung anlegen
CREATE DATABASE [Finnland] CONTAINMENT = PARTIAL COLLATE Finnish_Swedish_100_CI_AI;
GO

USE [Finnland];
GO

-- Tabelle anlegen
CREATE TABLE dbo.Orte
(
    Ort nvarchar(100),
	Region nvarchar(100)
);
INSERT INTO dbo.Orte VALUES('Helsinki', 'Sdfinnland');

-- Temporre Tabelle anlegen
CREATE TABLE #Regionen
(
    Region nvarchar(100)
);
INSERT INTO #Regionen VALUES('Sdfinnland');

-- Tabellen ber Zeichenfolge verknpfen
SELECT * FROM #Regionen INNER JOIN dbo.Orte ON #Regionen.Region = dbo.Orte.Region 
GO --> kein Fehler
