-- Nicht relationale Daten - Demo 4
-- Volltextsuche in Dateien und Dokumenten - NEAR


USE SNEK_FileTable
GO

-------------------------
-- Einfache Volltextsuche
-------------------------

-- Dokumente mit dem Begriff "SEK" 
SELECT	file_stream.GetFileNamespacePath(1, Null) As Pfad, [name] As Dokument
FROM	dbo.Dokumente 
WHERE	CONTAINS(file_stream, 'SEK') 


-------------------------
-- Volltextsuche mit NEAR
-------------------------

-- Dokumente mit den Begriffen "SQL Server" und "Access"
SELECT	file_stream.GetFileNamespacePath(1, Null) As Pfad, [name] As Dokument
FROM	dbo.Dokumente
WHERE	CONTAINS(file_stream, 'NEAR("SQL Server", Access)')
GO

-- Dokumente mit den Begriffen "Abhngigkeiten" und "ermitteln", 
-- die nicht durch mehr als 5 Wrter getrennt sind
SELECT	file_stream.GetFileNamespacePath(1, Null) As Pfad, 
		[name] As Dokument, creation_time 
FROM	dbo.Dokumente
WHERE	CONTAINS(file_stream, 'NEAR((Abhngigkeiten, ermitteln), 5)')
GO

-- Dokumente mit den Begriffen "Karl" und "SNEK", die nicht durch mehr
-- als 5 Wrter getrennt sind, wobei aber die Reihenfolge relevant ist
SELECT	file_stream.GetFileNamespacePath(1, Null) As Pfad, 
		[name] As Dokument, creation_time
FROM	dbo.Dokumente Doks
		INNER JOIN CONTAINSTABLE(dbo.Dokumente, file_stream, 'NEAR((Karl, SNEK), 5, TRUE)' ) As Suche
		ON doks.path_locator  = Suche.[KEY]
GO