-- Nicht relationale Daten - Demo 5
-- Volltextsuche in Dateien und Dokumenten - Eigenschaften


USE SNEK_FileTable
GO


------------------------------------
-- Sucheigenschaftenlisten erstellen 
------------------------------------

-- Sucheigenschaftenlisten anlegen
CREATE SEARCH PROPERTY LIST plDokument;

-- Sucheigenschaftenlisten mit den Eigenschaften Autor und Titel ergnzen
-- Die GUID des jeweiligen Eigenschaftensatz und die ID der Eigenschaften gibt's in der MSDN
ALTER SEARCH PROPERTY LIST plDokument
ADD	N'Author' 
WITH (PROPERTY_SET_GUID = 'f29f85e0-4ff9-1068-ab91-08002b27b3d9', 
	  PROPERTY_INT_ID = 4, 
	  PROPERTY_DESCRIPTION = N'System.Author');	

ALTER SEARCH PROPERTY LIST plDokument
ADD	N'Title' 
WITH (PROPERTY_SET_GUID = 'F29F85E0-4FF9-1068-AB91-08002B27B3D9', 
	  PROPERTY_INT_ID = 2, 
	  PROPERTY_DESCRIPTION = N'System.Title - Title of the item.');	

-- Zuordnen der Sucheigenschaftenliste zum Volltextindex
ALTER FULLTEXT INDEX ON dbo.Dokumente 
SET SEARCH PROPERTY LIST = plDokument;
GO


---------------------------------
-- Suche ber Datei-Eigenschaften
---------------------------------

-- Dokumente vom Autor "Bernd Jungbluth"
SELECT * FROM dbo.Dokumente WHERE CONTAINS(PROPERTY(file_stream, 'Author'), '"Bernd Jungbluth"')
