-- T-SQL - Demo 4
-- Konvertierungsfunktionen


--------------
-- TRY_CONVERT
--------------

-- Alte Version mit CONVERT
DECLARE @Wert As char(4) = '7777'
SELECT CONVERT(int, @Wert) As intSieben, CONVERT(tinyint, @Wert) As tinySieben
GO --> Fehler bei Konvertierung nach tinyint


-- Neue Version mit TRY_CONVERT
DECLARE @Wert As char(4) = '7777'
SELECT TRY_CONVERT(int, @Wert) As intSieben, TRY_CONVERT(tinyint, @Wert) As tinySieben
GO --> Kein Fehler bei Konvertierung nach tinyint, aber auch keinen Wert


-- TRY_CONVERT mit IIF
DECLARE @Wert As char(4) = '7777'
SELECT IIF(TRY_CONVERT(tinyint, @Wert) Is Null, TRY_CONVERT(integer, @Wert), TRY_CONVERT(tinyint, @Wert)) As Sieben
GO


-----------
-- TRY_CAST
-----------

-- Alte Version mit CAST
DECLARE @Wert As char(4) = '7777'
SELECT CAST(@Wert As Integer) As intSieben, CAST(@Wert As tinyint) As tinySieben
GO

-- Neue Version mit TRY_CAST
DECLARE @Wert As char(4) = '7777'
SELECT TRY_CAST(@Wert As Integer) As intSieben, TRY_CAST(@Wert As tinyint) As tinySieben
GO


--------
-- PARSE 
--------

-- Alte Version mit CONVERT
DECLARE @Tag As char(10) = '31.12.2012'
SELECT CONVERT(date, @Tag) As Datum
GO --> Kein Fehler


SET LANGUAGE 'us_english'
DECLARE @Tag As char(10) = '31.12.2012'
SELECT CONVERT(date, @Tag) As Datum
GO --> Fehler


-- Neue Version mit PARSE
SET LANGUAGE 'us_english'
DECLARE @Tag As char(10) = '31.12.2012'
SELECT PARSE(@Tag AS date USING 'de-DE') As Datum
GO --> Kein Fehler


-- Wert in zwei Lndereinstellungen konvertieren
DECLARE @Tag As char(10) = '06.07.2012'
SELECT PARSE(@Tag AS date USING 'de-DE') As Datum_de_DE, PARSE(@Tag AS date USING 'en-US') As Datum_en_US
GO


----------------------
-- TRY_PARSE und PARSE
----------------------

DECLARE @Tag As char(10) = '31.12.2012'
SELECT PARSE(@Tag AS date USING 'en-US') As Datum 
-- Fehler
SELECT TRY_PARSE(@Tag AS date USING 'en-US') As Datum
-- Kein Fehler
GO


-------------------------
-- Rcksetzen der Sprache
-------------------------
SET LANGUAGE 'German'