-- T-SQL - Demo 5
-- Datumsfunktionen


------------
-- FROMPARTS
------------

-- Datum anhand Jahr, Monat, Tag
SELECT DATEFROMPARTS(2012, 4, 24) As SNEK_ErsterTermin


-- SNEK-Termine im Jahr 2012
DECLARE @Jahr int = 2012,
		@Monat int = 3,
		@Tag int = 24

-- Erster SNEK-Termin
SELECT DATEFROMPARTS(@Jahr, @Monat, @Tag) As SNEK_ErsterTermin

-- Zweiter SNEK-Termin
SELECT DATEFROMPARTS(@Jahr, @Monat + 1, @Tag + 4) As SNEK_ZweiterTermin

-- Startzeit vom ersten Vortrag beim ersten Termin 
SELECT DATETIMEFROMPARTS(@Jahr, @Monat, @Tag, 9, 15, 0, 0) As StartZeit

-- Voraussichtliche Endezeit vom ersten Vortrag unabhngig vom Termin
SELECT TIMEFROMPARTS(10, 45, 0, 0, 0) As GeplantesEnde


----------
-- EOMONTH
----------

-- Letzter Tag vom aktuellen Monat
SELECT EOMONTH(Getdate())

-- Letzter Tag Februar 2012
DECLARE @Bsp1 As date = '2012-02-01'
SELECT EOMONTH(@Bsp1) As DatumLetzterTag

-- Letzter Tag Februar 2011
DECLARE @Bsp2 As date = '2011-02-01'
SELECT EOMONTH(@Bsp2) As DatumLetzterTag