-- T-SQL - Demo 6
-- Zeichenfolgenfunktionen - CONCAT und FORMAT


---------
-- CONCAT
---------

-- Zwei Zeichenfolgen verbinden
DECLARE @Vorname varchar(10) = 'Karl',
		@Nachname varchar(10) = 'Donaubauer'

-- Alte Version
SELECT @Vorname + ' ' + @Nachname As Name

-- Neue Version
SELECT CONCAT(@Vorname, ' ', @Nachname) As Name


-- Zeichenfolgen und Zahlen verbinden
DECLARE @Konferenz varchar(5) = 'SNEK',
		@Nummer int = 1
SELECT CONCAT(@Konferenz, @Nummer) As Konferenz


-- Zeichenfolgen und NULL-Werte verbinden
DECLARE @Titel varchar(10) -- = 'Dr.'
DECLARE	@Name varchar(10) = 'Guttenberg'
-- Alte Version
SELECT @Titel + ' ' + @Name As Name
-- Neue Version
SELECT CONCAT(@Titel, ' ', @Name) As Name


---------
-- FORMAT
---------

-- Aktuelles Datum im Format "01.05.2012"
SELECT FORMAT(GETDATE(), 'd') As Datum

-- Aktuelles Datum im Format "01 Mai"
SELECT FORMAT(GETDATE(), 'm') As Datum

-- Aktuelles Datum im Format "01. Mai 2012"
SELECT FORMAT(getdate(), 'dd. MMMM yyyy') As Datum

-- Datum im Format der angegebenen Lndereinstellung
DECLARE @Tag As date = '2012-06-07' 
SELECT FORMAT(@Tag, 'd', 'de-DE') As Datum
SELECT FORMAT(@Tag, 'd', 'en-US') As Datum


-- Zahl als Prozentwert
DECLARE @MwSt As decimal(3,2) = 0.19
SELECT FORMAT(@MwSt, 'p', 'de-DE') As MwSt


-- Zahl als Whrung - mit Lnderangabe
DECLARE @SNEK As money = 330
SELECT FORMAT(@SNEK, 'c', 'de-DE') As Betrag
SELECT FORMAT(@SNEK, 'c', 'en-US') As Betrag


-- Zahl mit fhrenden Nullen
USE SNEK
GO
SELECT FORMAT([Artikel-Nr], '00000') As ArtikelNr FROM dbo.Artikel