-- T-SQL - Demo 7
-- Logikfunktionen - IIF und CHOOSE

------
-- IIF
------

-- "SNEK-Nrnberg" oder "Wochenende" abhngig vom aktuellen Datum
SELECT IIF(Month(Getdate()) = 4 AND Day(Getdate()) = 24, 'SNEK-Nrnberg', 'Wochenende') As Termin


---------
-- CHOOSE
---------

-- Anlegen der Beispieltabelle  
USE SNEK
GO
CREATE TABLE dbo.Termine (ID int IDENTITY, Jahr int, Titel nvarchar(7))
INSERT INTO dbo.Termine VALUES (2007, 'SEK 1'), (2008, 'SEK 2'), (2009, 'SEK 3'),(2011, 'SEK 4'), (2012, 'SNEK 1')  

-- Titel der Konferenz zum Jahr 2012
-- ACHTUNG: Die Ermittlung erfolgt ber die ID, nicht ber das Jahr.
-- Das Jahr 2012 entspricht der ID 5, wodurch der 5. Eintrag der Liste gewhlt wird.
SELECT	CHOOSE(ID, 'SEK 1', 'SEK 2', 'SEK 3', 'SEK 4', 'SNEK 1') As Termin
FROM	dbo.Termine
WHERE	Jahr = 2012

-- Ermittlung ber das Jahr liefert kein Ergebnis.
-- ber die Spalte Jahr wrde der 2012. Eintrag der Liste gesucht
SELECT	CHOOSE(Jahr, 'SEK 1', 'SEK 2', 'SEK 3', 'SEK 4', 'SNEK 1') As Termin
FROM	dbo.Termine
WHERE	Jahr = 2012


-- Lschen der Beispieltabelle
DROP TABLE dbo.Termine

