-- T-SQL - Demo 8
-- Fehlerbehandlung mit THROW


--------
-- THROW
--------

-- Auslsen eines Fehlers mit THROW
THROW 50001, 'Es ist heute Samstag', 1


----------------------
-- THROW und TRY/CATCH
----------------------

-- TRY/CATCH ohne TRHOW
-- Klassische Fehlerbehebung ohne Auslsen des Fehlers
DECLARE @Wert1 int = 1, @Wert2 int = 0

SET NOCOUNT ON;
BEGIN TRY
	SELECT 'Step 1 - Berechnung: ' As [Status],  @Wert1 / @Wert2 As Ergebnis
END TRY
BEGIN CATCH
	SELECT 'Die Variable hat den Wert 0';
END CATCH
SELECT 'Step 2 - Aufbereiten' As [Status]
GO

-- TRY/CATCH mit TRHOW
-- Protokollieren und erneutes Auslsen des Fehlers
DECLARE @Wert1 int = 1, @Wert2 int = 0

SET NOCOUNT ON;
BEGIN TRY
	SELECT 'Step 1 - Berechnung: ' As [Status],  @Wert1 / @Wert2 As Ergebnis
END TRY
BEGIN CATCH
	SELECT 'Die Variable hat den Wert 0';  --> Semikolon nicht vergessen!
	THROW
END CATCH
SELECT 'Step 2 - Aufbereiten' As [Status]
GO